#! /usr/bin/env python

# Concatenate CRP file segments and write result to stdout

# Author: Frank Paehlke
# $Id: crpcat.py,v 1.2 2004/09/29 19:17:12 frank Exp $

import sys
from optparse import OptionParser
import string
import crputils_version

def main():
    global options
    # parse command line arguments
    parser = OptionParser(usage="%prog [options] [input file(s)]",
                          version=crputils_version.version)
    parser.add_option ("-v", "--verbose", action="store_true",
                       dest="verbose", default=False,
                       help="turn on debugging output")
    (options, args) = parser.parse_args()
    if args == []:
        ifilenames = ["-"]
    else:
        ifilenames = args
    
    if options.verbose:
        print >> sys.stderr, "Input files: ", ifilenames

    offset = 0 # offset [km/100]
    for ifilename in ifilenames:
        if ifilename == '-':
            if options.verbose:
                sys.stderr.write("Processing stdin\n") 
            ifile = sys.stdin
        else:
            if options.verbose:
                sys.stderr.write("Processing file" + `ifilename` + "\n") 
            ifile = open(ifilename)
        offset = copyFile(ifile, sys.stdout, offset)
        if (ifile != sys.stdin): ifile.close()

# do the actual concatenation, adding offset [km/100] to each distance value
# return last distance value (to be used as offset for next invocation)

def copyFile (ifile,ofile,offset):
    
    # skip header lines
    line = ifile.readline()
    if (line[0:3] == "HRM"):
        line = ifile.readline()
        line = ifile.readline()
    while 1:
        if not line or line[0:3] == "***": break
        # split the line into fields, get distance
        fields = string.split(line, '\t')
        dist = int(fields[2]) + offset
        # output line
        fields[2] = `dist`
        line = string.join (fields, '\t')
        ofile.write(line)
        # read next input line
        line = ifile.readline()
    if options.verbose:
        sys.stderr.write("start: " + str(offset*0.01) + " km\n")
        sys.stderr.write("end:   " + str(dist*0.01) + " km\n")
    return dist

main()
